' LVcommon.inc
' contains all the O2 macros , types,  functions and constants needed by a ListView control
' updated  Nov 10 2018

macro ListView_InsertColumn(hwnd,iCol,pcol) (SendMessage(hwnd, LVM_INSERTCOLUMN, iCol, pcol))
macro ListView_SetColumnWidth(hwnd,iCol,cx) (SendMessage(hwnd, LVM_SETCOLUMNWIDTH, iCol, cx))
macro ListView_InsertItem(hwnd,pitem) (SendMessage(hwnd, LVM_INSERTITEM,0, pitem))
macro ListView_SetItem(hwnd,pitem) (SendMessage(hwnd, LVM_SETITEM,0, pitem))



'  Constants
% LVS_LIST  0x0003
% LVS_REPORT  0x0001
% LVS_EX_GRIDLINES 1
% LVS_EX_CHECKBOXES 4
% LVS_EX_FULLROWSELECT  0x0020

%  LVS_SINGLESEL = 0x0004
%  LVS_EX_DOUBLEBUFFER = 0x0010000

'% LVSCW_AUTOSIZE  dword -1
'% LVSCW_AUTOSIZE_USEHEADER dword -2
% LVSCW_AUTOSIZE   -1
% LVSCW_AUTOSIZE_USEHEADER  -2


% LVCF_FMT 1
% LVCF_WIDTH 2
% LVCF_TEXT=4
% LVCF_SUBITEM 8
% LVCF_ORDER = 20
% LVIF_TEXT=1
% LVM_SETEXTENDEDLISTVIEWSTYLE 0x1036
% LVN_COLUMNCLICK = -108
% LVN_ITEMCHANGED = -101


' ListView messages
%  LVM_FIRST = &H1000
%  LVM_SETBKCOLOR = LVM_FIRST + 1
%  LVM_SETTEXTCOLOR       = LVM_FIRST + 36
%  LVM_GETHEADER          =  LVM_FIRST + 31

% LVM_INSERTCOLUMN=  LVM_FIRST + 27
% LVM_SETCOLUMNWIDTH=LVM_FIRST + 30
% LVM_INSERTITEM=%LVM_FIRST + 7
% LVM_SETITEM=LVM_FIRST + 6
% LVM_SETITEMSTATE       = LVM_FIRST + 43

% LVIS_FOCUSED           = &H0001
% LVIS_SELECTED          = &H0002



' Type definitions

type LVCOLUMN 
  uint  mask 
  int   fmt 
  int   cx 
  char* pszText 
  int   cchTextMax 
  int   iSubItem 
  int   iImage
  int   iOrder
  int   cxMin
  int   cxDefault
  int   cxIdeal  
end type 
typedef LVCOLUMN LV_COLUMN

type LVITEM  
  uint   mask 
  int    iItem 
  int    iSubItem 
  uint   state 
  uint   stateMask 
  char*  pszText 
  int    cchTextMax 
  int    iImage       // index of the list view item's icon 
  sys    lParam       // 32-bit value to associate with item 
  int    iIndent
  int    iGroupId
  uint   cColumns
  uint   *puColumns
  int    *piColFmt
  int    iGroup
end type

typedef LVITEM LV_ITEM


type NMLISTVIEW
  NMHDR hdr
  int   iItem
  int   iSubItem
  uint  uNewState
  uint  uOldState
  uint  uChanged
  POINT ptAction
  sys   lParam
end type

typedef NMLISTVIEW NM_LISTVIEW


TYPE NMCUSTOMDRAW 
   hdr         AS NMHDR   ' NMHDR     hdr
   dwDrawStage AS DWORD  ' DWORD     dwDrawStage
   hdc         AS sys   ' HDC       hdc
   rc          AS RECT    ' RECT      rc
   dwItemSpec  AS sys   ' DWORD_PTR dwItemSpec  // this is control specific, but it's how to specify an item. valid only with CDDS_ITEM bit set
   uItemState  AS uint   ' UINT      uItemState
   lItemlParam AS LONG    ' LPARAM    lItemlParam
END TYPE


TYPE NMLVCUSTOMDRAW 
   nmcd        AS  NMCUSTOMDRAW   ' NMCUSTOMDRAW nmcd
   clrText     AS sys          ' COLORREF clrText
   clrTextBk   AS sys          ' COLORREF clrTextBk
   iSubItem    AS LONG           ' int iSubItem
   dwItemType  AS DWORD         ' DWORD dwItemType
   ' // Item custom draw
   clrFace     AS sys          ' COLORREF clrFace
   iIconEffect AS LONG           ' int iIconEffect
   iIconPhase  AS LONG           ' int iIconPhase
   iPartId     AS LONG           ' int iPartId
   iStateId    AS LONG           ' int iStateId
   ' // Group Custom Draw
   rcText      AS RECT           ' RECT rcText
   uAlign      AS uint             ' UINT uAlign  // Alignment. Use LVGA_HEADER_CENTER, LVGA_HEADER_RIGHT, LVGA_HEADER_LEFT

END TYPE




' ========================================================================================
' Changes the state of an item in a list-view control.
' ========================================================================================
SUB ListView_SetItemState (BYVAL hwndLV AS sys, BYVAL i AS LONG, BYVAL dwState AS sys, BYVAL mask AS sys)
   LOCAL lvi AS LVITEM
   lvi.stateMask = mask
   lvi.state = dwState
   SendMessage hwndLV, LVM_SETITEMSTATE, i, VARPTR(lvi)
END SUB
